addHook("PlayerThink", function(player)
	if player.flying == nil
		player.flying = false
	end
	if player.prevz == nil
		player.prevz = player.mo.z
	end
	if player.sprung == nil
		player.sprung = false
	end
	if player.shouldfly == nil
		player.shouldfly = false
	end
	if (player.mo.eflags & MFE_SPRUNG)
		player.sprung = true
	elseif (player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)
		player.sprung = false
	end
	if ((player.pflags & PF_JUMPED) or (player.pflags & PF_THOKKED))
	or ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo) or player.mo.standingslope)
	or player.sprung and player.mo.momz == 0
		if player.mo.standingslope
		and player.prevz > player.mo.z
			P_SetOrigin(player.mo, player.mo.x, player.mo.y, player.mo.z + 1*FRACUNIT)
		end
		player.prevz = player.mo.z
	end
	if player.sprung and player.mo.momz == 0
		player.shouldfly = true
	end
	if not ((player.pflags & PF_JUMPED) or (player.pflags & PF_THOKKED))
	and not ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo) or player.mo.standingslope)
	and not (player.powers[pw_carry] or player.playerstate == PST_DEAD or P_PlayerInPain(player))
	or player.shouldfly == true
		if player.sprung and player.mo.momz ~= 0 return end
		P_SetObjectMomZ(player.mo, 0*FRACUNIT, false)
		player.mo.z = player.prevz
		player.flying = true
		if player.shouldfly == true
			player.shouldfly = false
		end
	else
		player.flying = false
	end
	if (player.cmd.buttons & BT_JUMP)
	and not P_IsObjectOnGround(player.mo)
	and player.flying
		P_DoJump(player, true)
		player.flying = false
	end
	if (player.cmd.buttons & BT_USE)
	and not P_IsObjectOnGround(player.mo)
	and player.flying
	and not (player.pflags & PF_SPINNING)
	and not (player.pflags & PF_STARTDASH)
		if player.speed > 5*FRACUNIT
			player.pflags = $|PF_SPINNING
			player.mo.state = S_PLAY_ROLL
			S_StartSound(player.mo, sfx_spin)
		end
	end
	if player.flying
	and not (player.powers[pw_carry] or player.playerstate == PST_DEAD or P_PlayerInPain(player))
	and not (player.pflags & PF_SPINNING)
	and not (player.pflags & PF_STARTDASH)
		if player.speed == 0*FRACUNIT
			player.mo.state = S_PLAY_STND
		elseif player.speed < skins[player.mo.skin].runspeed
		and player.speed ~= 0*FRACUNIT
		and player.mo.state ~= S_PLAY_WALK
			player.mo.state = S_PLAY_WALK
		elseif player.speed >= skins[player.mo.skin].runspeed
		and player.mo.state ~= S_PLAY_RUN
			player.mo.state = S_PLAY_RUN
		end
	end
	if player.flying
	and player.speed < 6*FRACUNIT
	and (player.pflags & PF_SPINNING)
		player.pflags = $ & ~PF_SPINNING
	end
end)